Index: trunk/client/modules/Elezioni/grafici/jpgraph.php
===================================================================
--- trunk/client/modules/Elezioni/grafici/jpgraph.php	(revision 264)
+++ trunk/client/modules/Elezioni/grafici/jpgraph.php	(revision 265)
@@ -1,10 +1,10 @@
 <?php
 //=======================================================================
-// File:	JPGRAPH.PHP
-// Description:	PHP Graph Plotting library. Base module.
-// Created: 	2001-01-08
-// Ver:		$Id: jpgraph.php 1091 2009-01-18 22:57:40Z ljp $
+// File:        JPGRAPH.PHP
+// Description: PHP Graph Plotting library. Base module.
+// Created:     2001-01-08
+// Ver:         $Id: jpgraph.php 1924 2010-01-11 14:03:26Z ljp $
 //
-// Copyright (c) Aditus Consulting. All rights reserved.
+// Copyright (c) Asial Corporation. All rights reserved.
 //========================================================================
 
@@ -16,74 +16,31 @@
 require_once('jpgraph_text.inc.php');
 require_once('jpgraph_legend.inc.php');
+require_once('jpgraph_theme.inc.php');
+require_once('gd_image.inc.php');
 
 // Version info
-define('JPG_VERSION','2.3.5-dev');
+define('JPG_VERSION','4.2.6');
 
 // Minimum required PHP version
 define('MIN_PHPVERSION','5.1.0');
 
-// Should the image be a truecolor image? 
-define('USE_TRUECOLOR',true);
-
-//------------------------------------------------------------------------
-// Automatic settings of path for cache and font directory
-// if they have not been previously specified
-//------------------------------------------------------------------------
-if(USE_CACHE) {
-    if (!defined('CACHE_DIR')) {
-	if ( strstr( PHP_OS, 'WIN') ) {
-	    if( empty($_SERVER['TEMP']) ) {
-		$t = new ErrMsgText();
-		$msg = $t->Get(11,$file,$lineno);
-		die($msg);
-	    }
-	    else {
-		define('CACHE_DIR', $_SERVER['TEMP'] . '/');
-	    }
-	} else {
-	    define('CACHE_DIR','/tmp/jpgraph_cache/');
-	}
-    }
-}
-elseif( !defined('CACHE_DIR') ) {
-    define('CACHE_DIR', '');
-}
-
-if (!defined('TTF_DIR')) {
-    if (strstr( PHP_OS, 'WIN') ) {
-	$sroot = getenv('SystemRoot');
-        if( empty($sroot) ) {
-	    $t = new ErrMsgText();
-	    $msg = $t->Get(12,$file,$lineno);
-	    die($msg);
-        }
-	else {
-	  define('TTF_DIR', $sroot.'/fonts/');
-        }
-    } else {
-	define('TTF_DIR','/usr/share/fonts/truetype/');
-    }
-}
-
-if (!defined('MBTTF_DIR')) {
-    if (strstr( PHP_OS, 'WIN') ) {
-	$sroot = getenv('SystemRoot');
-        if( empty($sroot) ) {
-	    $t = new ErrMsgText();
-	    $msg = $t->Get(12,$file,$lineno);
-	    die($msg);
-        }
-	else {
-	  define('TTF_DIR', $sroot.'/fonts/');
-        }
-    } else {
-	define('MBTTF_DIR','/usr/share/fonts/ja/TrueType/');
-    }
-}
-
-//------------------------------------------------------------------
-// Constants which are used as parameters for the method calls
-//------------------------------------------------------------------
-
+// Special file name to indicate that we only want to calc
+// the image map in the call to Graph::Stroke() used
+// internally from the GetHTMLCSIM() method.
+define('_CSIM_SPECIALFILE','_csim_special_');
+
+// HTTP GET argument that is used with image map
+// to indicate to the script to just generate the image
+// and not the full CSIM HTML page.
+define('_CSIM_DISPLAY','_jpg_csimd');
+
+// Special filename for Graph::Stroke(). If this filename is given
+// then the image will NOT be streamed to browser of file. Instead the
+// Stroke call will return the handler for the created GD image.
+define('_IMG_HANDLER','__handle');
+
+// Special filename for Graph::Stroke(). If this filename is given
+// the image will be stroked to a file with a name based on the script name.
+define('_IMG_AUTO','auto');
 
 // Tick density
@@ -93,5 +50,5 @@
 define("TICKD_VERYSPARSE",4);
 
-// Side for ticks and labels. 
+// Side for ticks and labels.
 define("SIDE_LEFT",-1);
 define("SIDE_RIGHT",1);
@@ -156,5 +113,4 @@
 define("HORIZONTAL",0);
 
-
 // Axis styles for scientific style axis
 define('AXSTYLE_SIMPLE',1);
@@ -176,4 +132,14 @@
 define('TITLEBKG_FILLSTYLE_SOLID',3);
 
+// Styles for axis labels background
+define('LABELBKG_NONE',0);
+define('LABELBKG_XAXIS',1);
+define('LABELBKG_YAXIS',2);
+define('LABELBKG_XAXISFULL',3);
+define('LABELBKG_YAXISFULL',4);
+define('LABELBKG_XYFULL',5);
+define('LABELBKG_XY',6);
+
+
 // Style for background gradient fills
 define('BGRAD_FRAME',1);
@@ -191,10 +157,4 @@
 define('SKEW3D_RIGHT',3);
 
-// Line styles
-define('LINESTYLE_SOLID',1);
-define('LINESTYLE_DOTTED',2);
-define('LINESTYLE_DASHED',3);
-define('LINESTYLE_LONGDASH',4);
-
 // For internal use only
 define("_JPG_DEBUG",false);
@@ -202,18 +162,84 @@
 define("_FORCE_IMGDIR",'/tmp/jpgimg/');
 
-require_once('gd_image.inc.php');
-
-function CheckPHPVersion($aMinVersion)
-{
-    list($majorC, $minorC, $editC) = split('[/.-]', PHP_VERSION);
-    list($majorR, $minorR, $editR) = split('[/.-]', $aMinVersion);
-  
-    if ($majorC != $majorR) return false;
+
+//
+// Automatic settings of path for cache and font directory
+// if they have not been previously specified
+//
+if(USE_CACHE) {
+    if (!defined('CACHE_DIR')) {
+        if ( strstr( PHP_OS, 'WIN') ) {
+            if( empty($_SERVER['TEMP']) ) {
+                $t = new ErrMsgText();
+                $msg = $t->Get(11,$file,$lineno);
+                die($msg);
+            }
+            else {
+                define('CACHE_DIR', $_SERVER['TEMP'] . '/');
+            }
+        } else {
+            define('CACHE_DIR','/tmp/jpgraph_cache/');
+        }
+    }
+}
+elseif( !defined('CACHE_DIR') ) {
+    define('CACHE_DIR', '');
+}
+
+//
+// Setup path for western/latin TTF fonts
+//
+if (!defined('TTF_DIR')) {
+    if (strstr( PHP_OS, 'WIN') ) {
+        $sroot = getenv('SystemRoot');
+        if( empty($sroot) ) {
+            $t = new ErrMsgText();
+            $msg = $t->Get(12,$file,$lineno);
+            die($msg);
+        }
+        else {
+            define('TTF_DIR', $sroot.'/fonts/');
+        }
+    } else {
+        define('TTF_DIR','/usr/share/fonts/truetype/');
+    }
+}
+
+//
+// Setup path for MultiByte TTF fonts (japanese, chinese etc.)
+//
+if (!defined('MBTTF_DIR')) {
+    if (strstr( PHP_OS, 'WIN') ) {
+        $sroot = getenv('SystemRoot');
+        if( empty($sroot) ) {
+            $t = new ErrMsgText();
+            $msg = $t->Get(12,$file,$lineno);
+            die($msg);
+        }
+        else {
+            define('MBTTF_DIR', $sroot.'/fonts/');
+        }
+    } else {
+        define('MBTTF_DIR','/usr/share/fonts/truetype/');
+    }
+}
+
+//
+// Check minimum PHP version
+//
+function CheckPHPVersion($aMinVersion) {
+    list($majorC, $minorC, $editC) = preg_split('/[\/.-]/', PHP_VERSION);
+    list($majorR, $minorR, $editR) = preg_split('/[\/.-]/', $aMinVersion);
+
     if ($majorC < $majorR) return false;
-    // same major - check ninor
-    if ($minorC > $minorR) return true;
-    if ($minorC < $minorR) return false;
-    // and same minor
-    if ($editC  >= $editR)  return true;
+
+    if ($majorC == $majorR) {
+        if($minorC < $minorR) return false;
+
+        if($minorC == $minorR){
+            if($editC < $editR) return false;
+        }
+    }
+
     return true;
 }
@@ -227,5 +253,4 @@
 }
 
-
 //
 // Make GD sanity check
@@ -233,5 +258,5 @@
 if( !function_exists("imagetypes") || !function_exists('imagecreatefromstring') ) {
     JpGraphError::RaiseL(25001);
-//("This PHP installation is not configured with the GD library. Please recompile PHP with GD support to run JpGraph. (Neither function imagetypes() nor imagecreatefromstring() does exist)");
+    //("This PHP installation is not configured with the GD library. Please recompile PHP with GD support to run JpGraph. (Neither function imagetypes() nor imagecreatefromstring() does exist)");
 }
 
@@ -242,5 +267,5 @@
     // Respect current error level
     if( $errno & error_reporting() ) {
-	JpGraphError::RaiseL(25003,basename($filename),$linenum,$errmsg); 
+        JpGraphError::RaiseL(25003,basename($filename),$linenum,$errmsg);
     }
 }
@@ -251,24 +276,25 @@
 
 //
-//Check if there were any warnings, perhaps some wrong includes by the
-//user
+// Check if there were any warnings, perhaps some wrong includes by the user. In this
+// case we raise it immediately since otherwise the image will not show and makes
+// debugging difficult. This is controlled by the user setting CATCH_PHPERRMSG
 //
-if( isset($GLOBALS['php_errormsg']) && CATCH_PHPERRMSG && 
-    !preg_match('/|Deprecated|/i', $GLOBALS['php_errormsg']) ) {
+if( isset($GLOBALS['php_errormsg']) && CATCH_PHPERRMSG && !preg_match('/|Deprecated|/i', $GLOBALS['php_errormsg']) ) {
     JpGraphError::RaiseL(25004,$GLOBALS['php_errormsg']);
 }
 
-
 // Useful mathematical function
 function sign($a) {return $a >= 0 ? 1 : -1;}
 
+//
 // Utility function to generate an image name based on the filename we
 // are running from and assuming we use auto detection of graphic format
 // (top level), i.e it is safe to call this function
 // from a script that uses JpGraph
+//
 function GenImgName() {
     // Determine what format we should use when we save the images
     $supported = imagetypes();
-    if( $supported & IMG_PNG )	   $img_format="png";
+    if( $supported & IMG_PNG )    $img_format="png";
     elseif( $supported & IMG_GIF ) $img_format="gif";
     elseif( $supported & IMG_JPG ) $img_format="jpeg";
@@ -277,18 +303,18 @@
 
 
-    if( !isset($_SERVER['PHP_SELF']) )
-	JpGraphError::RaiseL(25005);
-//(" Can't access PHP_SELF, PHP global variable. You can't run PHP from command line if you want to use the 'auto' naming of cache or image files.");
+    if( !isset($_SERVER['PHP_SELF']) ) {
+        JpGraphError::RaiseL(25005);
+        //(" Can't access PHP_SELF, PHP global variable. You can't run PHP from command line if you want to use the 'auto' naming of cache or image files.");
+    }
     $fname = basename($_SERVER['PHP_SELF']);
     if( !empty($_SERVER['QUERY_STRING']) ) {
-	$q = @$_SERVER['QUERY_STRING'];
-	$fname .= '_'.preg_replace("/\W/", "_", $q).'.'.$img_format;
+        $q = @$_SERVER['QUERY_STRING'];
+        $fname .= '_'.preg_replace("/\W/", "_", $q).'.'.$img_format;
     }
     else {
-	$fname = substr($fname,0,strlen($fname)-4).'.'.$img_format;
+        $fname = substr($fname,0,strlen($fname)-4).'.'.$img_format;
     }
     return $fname;
 }
-
 
 //===================================================
@@ -299,18 +325,14 @@
 //===================================================
 class JpgTimer {
-    private $start, $idx;	
-//---------------
-// CONSTRUCTOR
-    function JpgTimer() {
-	$this->idx=0;
-    }
-
-//---------------
-// PUBLIC METHODS	
+    private $start, $idx;
+
+    function __construct() {
+        $this->idx=0;
+    }
 
     // Push a new timer start on stack
     function Push() {
-	list($ms,$s)=explode(" ",microtime());	
-	$this->start[$this->idx++]=floor($ms*1000) + 1000*$s;	
+        list($ms,$s)=explode(" ",microtime());
+        $this->start[$this->idx++]=floor($ms*1000) + 1000*$s;
     }
 
@@ -318,13 +340,12 @@
     // current time
     function Pop() {
-	assert($this->idx>0);
-	list($ms,$s)=explode(" ",microtime());	
-	$etime=floor($ms*1000) + (1000*$s);
-	$this->idx--;
-	return $etime-$this->start[$this->idx];
+        assert($this->idx>0);
+        list($ms,$s)=explode(" ",microtime());
+        $etime=floor($ms*1000) + (1000*$s);
+        $this->idx--;
+        return $etime-$this->start[$this->idx];
     }
 } // Class
 
-$gJpgBrandTiming = BRAND_TIMING;
 //===================================================
 // CLASS DateLocale
@@ -332,94 +353,89 @@
 //===================================================
 class DateLocale {
- 
+
     public $iLocale = 'C'; // environmental locale be used by default
     private $iDayAbb = null, $iShortDay = null, $iShortMonth = null, $iMonthName = null;
 
-//---------------
-// CONSTRUCTOR	
-    function DateLocale() {
-	settype($this->iDayAbb, 'array');
-	settype($this->iShortDay, 'array');
-	settype($this->iShortMonth, 'array');
-	settype($this->iMonthName, 'array');
-
-
-	$this->Set('C');
-    }
-
-//---------------
-// PUBLIC METHODS	
+    function __construct() {
+        settype($this->iDayAbb, 'array');
+        settype($this->iShortDay, 'array');
+        settype($this->iShortMonth, 'array');
+        settype($this->iMonthName, 'array');
+        $this->Set('C');
+    }
+
     function Set($aLocale) {
-	if ( in_array($aLocale, array_keys($this->iDayAbb)) ){ 
-	    $this->iLocale = $aLocale;
-	    return TRUE;  // already cached nothing else to do!
-	}
-
-	$pLocale = setlocale(LC_TIME, 0); // get current locale for LC_TIME
-
-	if (is_array($aLocale)) {
-	    foreach ($aLocale as $loc) {
-		$res = @setlocale(LC_TIME, $loc);
-		if ( $res ) {
-		    $aLocale = $loc;
-		    break;
-		}
-	    }
-	}
-	else {
-	    $res = @setlocale(LC_TIME, $aLocale);
-	}
-
-	if ( ! $res ){
-	    JpGraphError::RaiseL(25007,$aLocale);
-//("You are trying to use the locale ($aLocale) which your PHP installation does not support. Hint: Use '' to indicate the default locale for this geographic region.");
-	    return FALSE;
-	}
- 
-	$this->iLocale = $aLocale;
-	for ( $i = 0, $ofs = 0 - strftime('%w'); $i < 7; $i++, $ofs++ ){
-	    $day = strftime('%a', strtotime("$ofs day"));
-	    $day[0] = strtoupper($day[0]);
-	    $this->iDayAbb[$aLocale][]= $day[0];
-	    $this->iShortDay[$aLocale][]= $day;
-	}
-
-	for($i=1; $i<=12; ++$i) {
-	    list($short ,$full) = explode('|', strftime("%b|%B",strtotime("2001-$i-01")));
-	    $this->iShortMonth[$aLocale][] = ucfirst($short);
-	    $this->iMonthName [$aLocale][] = ucfirst($full);
-	}
-		
-	setlocale(LC_TIME, $pLocale);
-
-	return TRUE;
+        if ( in_array($aLocale, array_keys($this->iDayAbb)) ){
+            $this->iLocale = $aLocale;
+            return TRUE;  // already cached nothing else to do!
+        }
+
+        $pLocale = setlocale(LC_TIME, 0); // get current locale for LC_TIME
+
+        if (is_array($aLocale)) {
+            foreach ($aLocale as $loc) {
+                $res = @setlocale(LC_TIME, $loc);
+                if ( $res ) {
+                    $aLocale = $loc;
+                    break;
+                }
+            }
+        }
+        else {
+            $res = @setlocale(LC_TIME, $aLocale);
+        }
+
+        if ( ! $res ) {
+            JpGraphError::RaiseL(25007,$aLocale);
+            //("You are trying to use the locale ($aLocale) which your PHP installation does not support. Hint: Use '' to indicate the default locale for this geographic region.");
+            return FALSE;
+        }
+
+        $this->iLocale = $aLocale;
+        for( $i = 0, $ofs = 0 - strftime('%w'); $i < 7; $i++, $ofs++ ) {
+            $day = strftime('%a', strtotime("$ofs day"));
+            $day[0] = strtoupper($day[0]);
+            $this->iDayAbb[$aLocale][]= $day[0];
+            $this->iShortDay[$aLocale][]= $day;
+        }
+
+        for($i=1; $i<=12; ++$i) {
+            list($short ,$full) = explode('|', strftime("%b|%B",strtotime("2001-$i-01")));
+            $this->iShortMonth[$aLocale][] = ucfirst($short);
+            $this->iMonthName [$aLocale][] = ucfirst($full);
+        }
+
+        setlocale(LC_TIME, $pLocale);
+
+        return TRUE;
     }
 
 
     function GetDayAbb() {
-	return $this->iDayAbb[$this->iLocale];
-    }
-	
+        return $this->iDayAbb[$this->iLocale];
+    }
+
     function GetShortDay() {
-	return $this->iShortDay[$this->iLocale];
+        return $this->iShortDay[$this->iLocale];
     }
 
     function GetShortMonth() {
-	return $this->iShortMonth[$this->iLocale];
-    }
-	
+        return $this->iShortMonth[$this->iLocale];
+    }
+
     function GetShortMonthName($aNbr) {
-	return $this->iShortMonth[$this->iLocale][$aNbr];
+        return $this->iShortMonth[$this->iLocale][$aNbr];
     }
 
     function GetLongMonthName($aNbr) {
-	return $this->iMonthName[$this->iLocale][$aNbr];
+        return $this->iMonthName[$this->iLocale][$aNbr];
     }
 
     function GetMonth() {
-	return $this->iMonthName[$this->iLocale];
+        return $this->iMonthName[$this->iLocale];
     }
 }
 
+// Global object handlers
 $gDateLocale = new DateLocale();
 $gJpgDateLocale = new DateLocale();
@@ -432,33 +448,42 @@
     public $iLeftMargin = 3, $iRightMargin = 3, $iBottomMargin = 3 ;
     public $left,$center,$right;
-
-    function Footer() {
-	$this->left = new Text();
-	$this->left->ParagraphAlign('left');
-	$this->center = new Text();
-	$this->center->ParagraphAlign('center');
-	$this->right = new Text();
-	$this->right->ParagraphAlign('right');
+    private $iTimer=null, $itimerpoststring='';
+
+    function __construct() {
+        $this->left = new Text();
+        $this->left->ParagraphAlign('left');
+        $this->center = new Text();
+        $this->center->ParagraphAlign('center');
+        $this->right = new Text();
+        $this->right->ParagraphAlign('right');
+    }
+
+    function SetTimer($aTimer,$aTimerPostString='') {
+        $this->iTimer = $aTimer;
+        $this->itimerpoststring = $aTimerPostString;
     }
 
     function SetMargin($aLeft=3,$aRight=3,$aBottom=3) {
-	$this->iLeftMargin = $aLeft;
-	$this->iRightMargin = $aRight;
-	$this->iBottomMargin = $aBottom;
+        $this->iLeftMargin = $aLeft;
+        $this->iRightMargin = $aRight;
+        $this->iBottomMargin = $aBottom;
     }
 
     function Stroke($aImg) {
-	$y = $aImg->height - $this->iBottomMargin;
-	$x = $this->iLeftMargin;
-	$this->left->Align('left','bottom');
-	$this->left->Stroke($aImg,$x,$y);
-
-	$x = ($aImg->width - $this->iLeftMargin - $this->iRightMargin)/2;
-	$this->center->Align('center','bottom');
-	$this->center->Stroke($aImg,$x,$y);
-
-	$x = $aImg->width - $this->iRightMargin;
-	$this->right->Align('right','bottom');
-	$this->right->Stroke($aImg,$x,$y);
+        $y = $aImg->height - $this->iBottomMargin;
+        $x = $this->iLeftMargin;
+        $this->left->Align('left','bottom');
+        $this->left->Stroke($aImg,$x,$y);
+
+        $x = ($aImg->width - $this->iLeftMargin - $this->iRightMargin)/2;
+        $this->center->Align('center','bottom');
+        $this->center->Stroke($aImg,$x,$y);
+
+        $x = $aImg->width - $this->iRightMargin;
+        $this->right->Align('right','bottom');
+        if( $this->iTimer != null ) {
+            $this->right->Set( $this->right->t . sprintf('%.3f',$this->iTimer->Pop()/1000.0) . $this->itimerpoststring );
+        }
+        $this->right->Stroke($aImg,$x,$y);
     }
 }
@@ -470,30 +495,30 @@
 //===================================================
 class Graph {
-    public $cache=null;			// Cache object (singleton)
-    public $img=null;			// Img object (singleton)
-    public $plots=array();		// Array of all plot object in the graph (for Y 1 axis)
-    public $y2plots=array();		// Array of all plot object in the graph (for Y 2 axis)
+    public $cache=null;   // Cache object (singleton)
+    public $img=null;   // Img object (singleton)
+    public $plots=array();  // Array of all plot object in the graph (for Y 1 axis)
+    public $y2plots=array();  // Array of all plot object in the graph (for Y 2 axis)
     public $ynplots=array();
-    public $xscale=null;		// X Scale object (could be instance of LinearScale or LogScale
+    public $xscale=null;  // X Scale object (could be instance of LinearScale or LogScale
     public $yscale=null,$y2scale=null, $ynscale=array();
-    public $iIcons = array();		// Array of Icons to add to 
-    public $cache_name;			// File name to be used for the current graph in the cache directory
-    public $xgrid=null;			// X Grid object (linear or logarithmic)
-    public $ygrid=null,$y2grid=null;	//dito for Y
-    public $doframe=true,$frame_color=array(0,0,0), $frame_weight=1;	// Frame around graph
-    public $boxed=false, $box_color=array(0,0,0), $box_weight=1;		// Box around plot area
-    public $doshadow=false,$shadow_width=4,$shadow_color=array(102,102,102);	// Shadow for graph
-    public $xaxis=null;			// X-axis (instane of Axis class)
-    public $yaxis=null, $y2axis=null, $ynaxis=array();	// Y axis (instance of Axis class)
-    public $margin_color=array(200,200,200);	// Margin color of graph
-    public $plotarea_color=array(255,255,255);	// Plot area color
-    public $title,$subtitle,$subsubtitle; 	// Title and subtitle(s) text object
-    public $axtype="linlin";		// Type of axis
-    public $xtick_factor,$ytick_factor;	// Factor to determine the maximum number of ticks depending on the plot width
-    public $texts=null, $y2texts=null;	// Text object to ge shown in the graph
+    public $iIcons = array();  // Array of Icons to add to
+    public $cache_name;   // File name to be used for the current graph in the cache directory
+    public $xgrid=null;   // X Grid object (linear or logarithmic)
+    public $ygrid=null,$y2grid=null; //dito for Y
+    public $doframe,$frame_color, $frame_weight; // Frame around graph
+    public $boxed=false, $box_color='black', $box_weight=1;  // Box around plot area
+    public $doshadow=false,$shadow_width=4,$shadow_color='gray@0.5'; // Shadow for graph
+    public $xaxis=null;   // X-axis (instane of Axis class)
+    public $yaxis=null, $y2axis=null, $ynaxis=array(); // Y axis (instance of Axis class)
+    public $margin_color; // Margin color of graph
+    public $plotarea_color=array(255,255,255); // Plot area color
+    public $title,$subtitle,$subsubtitle;  // Title and subtitle(s) text object
+    public $axtype="linlin";  // Type of axis
+    public $xtick_factor,$ytick_factor; // Factor to determine the maximum number of ticks depending on the plot width
+    public $texts=null, $y2texts=null; // Text object to ge shown in the graph
     public $lines=null, $y2lines=null;
     public $bands=null, $y2bands=null;
-    public $text_scale_off=0, $text_scale_abscenteroff=-1;	// Text scale in fractions and for centering bars
-    public $background_image="",$background_image_type=-1,$background_image_format="png";
+    public $text_scale_off=0, $text_scale_abscenteroff=-1; // Text scale in fractions and for centering bars
+    public $background_image='',$background_image_type=-1,$background_image_format="png";
     public $background_image_bright=0,$background_image_contr=0,$background_image_sat=0;
     public $background_image_xpos=0,$background_image_ypos=0;
@@ -501,5 +526,5 @@
     public $inline;
     public $showcsim=0,$csimcolor="red";//debug stuff, draw the csim boundaris on the image if <>0
-    public $grid_depth=DEPTH_BACK;	// Draw grid under all plots as default
+    public $grid_depth=DEPTH_BACK; // Draw grid under all plots as default
     public $iAxisStyle = AXSTYLE_SIMPLE;
     public $iCSIMdisplay=false,$iHasStroked = false;
@@ -511,16 +536,19 @@
     public $bkg_gradtype=-1,$bkg_gradstyle=BGRAD_MARGIN;
     public $bkg_gradfrom='navy', $bkg_gradto='silver';
+    public $plot_gradtype=-1,$plot_gradstyle=BGRAD_MARGIN;
+    public $plot_gradfrom='silver', $plot_gradto='navy';
+
     public $titlebackground = false;
     public $titlebackground_color = 'lightblue',
-	$titlebackground_style = 1,
-	$titlebackground_framecolor = 'blue',
-	$titlebackground_framestyle = 2,
-	$titlebackground_frameweight = 1,
-	$titlebackground_bevelheight = 3 ;
+           $titlebackground_style = 1,
+           $titlebackground_framecolor,
+           $titlebackground_framestyle,
+           $titlebackground_frameweight,
+           $titlebackground_bevelheight;
     public $titlebkg_fillstyle=TITLEBKG_FILLSTYLE_SOLID;
     public $titlebkg_scolor1='black',$titlebkg_scolor2='white';
-    public $framebevel = false, $framebeveldepth = 2 ;
-    public $framebevelborder = false, $framebevelbordercolor='black';
-    public $framebevelcolor1='white@0.4', $framebevelcolor2='black@0.4';
+    public $framebevel, $framebeveldepth;
+    public $framebevelborder, $framebevelbordercolor;
+    public $framebevelcolor1, $framebevelcolor2;
     public $background_image_mix=100;
     public $background_cflag = '';
